"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParseImpressions = exports.ParseOptions = exports.Compositor = void 0;
// eslint-disable-next-line @typescript-eslint/no-unused-vars, no-unused-vars
var react_1 = __importDefault(require("react"));
// import { Parallax, ParallaxProvider } from "react-scroll-parallax"
var helper_1 = require("./helper");
var Compositor = function (_a) {
    var panesPayload = _a.panesPayload, tailwindBgColour = _a.tailwindBgColour, viewportKey = _a.viewportKey, hooks = _a.hooks, id = _a.id;
    var thisCss = "";
    var hasH5P = false;
    var contentMap = {};
    var contentChildren = {};
    var impressions = {};
    var paneIds = [];
    var hasMaxHScreen, heldBeliefs, withheldBeliefs;
    var isContextPane = id === null || id === void 0 ? void 0 : id.isContextPane;
    var keys = isContextPane ? ["all"] : ["mobile", "tablet", "desktop"];
    var check = "^bg-(w*-w*|w*)";
    var useTailwindBgColour = tailwindBgColour && tailwindBgColour.match(check) ? tailwindBgColour : "";
    panesPayload === null || panesPayload === void 0 ? void 0 : panesPayload.forEach(function (p) {
        paneIds.push(p.id);
        keys.forEach(function (key) {
            var _a;
            var hasCodeHook = {};
            var hasHiddenPane = false;
            var hasOverflowHidden = false;
            var paneHeightRatio = p.heightRatio
                ? p.heightRatio
                : viewportKey === "desktop" && p.heightRatioDesktop
                    ? p.heightRatioDesktop
                    : viewportKey === "tablet" && p.heightRatioTablet
                        ? p.heightRatioTablet
                        : viewportKey === "mobile" && p.heightRatioMobile
                            ? p.heightRatioMobile
                            : "0";
            var height = (helper_1.viewportWidth[key] * Number(paneHeightRatio)) / 100;
            var thisPanePayload = PaneCompositor(p, key, hooks, id);
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasH5P)
                hasH5P = true;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasHiddenPane)
                hasHiddenPane = true;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasCodeHook)
                hasCodeHook = thisPanePayload.hasCodeHook;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.heldBeliefs)
                heldBeliefs = thisPanePayload.heldBeliefs;
            else
                heldBeliefs = null;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.withheldBeliefs)
                withheldBeliefs = thisPanePayload.withheldBeliefs;
            else
                withheldBeliefs = null;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasMaxHScreen)
                hasMaxHScreen = true;
            else
                hasMaxHScreen = false;
            if (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.hasOverflowHidden)
                hasOverflowHidden = true;
            if (typeof ((_a = thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.impressions) === null || _a === void 0 ? void 0 : _a.payload) === "object")
                impressions[p.id] = __assign(__assign({}, thisPanePayload.impressions.payload), { id: p.id });
            if (typeof (thisPanePayload === null || thisPanePayload === void 0 ? void 0 : thisPanePayload.css) === "string")
                thisCss = "".concat(thisCss, " ").concat(thisPanePayload.css, " ");
            if (height === 0)
                thisCss = "#".concat(key, "-").concat(p.id, " { height: auto; } ").concat(thisCss, " ");
            else if (height > 0)
                thisCss =
                    "#".concat(key, "-").concat(p.id, " { height: calc(var(--scale) * ").concat(height, " * 1px); } ") +
                        "".concat(thisCss, " ");
            var thisChildren = thisPanePayload.children.filter(function (e) {
                return Object.keys(e).length;
            });
            if ((id === null || id === void 0 ? void 0 : id.isBuilderPreview) && thisChildren.length === 0)
                contentChildren["".concat(key, "-").concat(p.id)] = (react_1.default.createElement("div", { className: "py-16 flex items-center justify-center" },
                    react_1.default.createElement("p", null, "[Code hook inserted here]")));
            else
                contentChildren["".concat(key, "-").concat(p.id)] = thisChildren;
            contentMap[p.id] = {
                title: p.title,
                slug: p.slug,
                type: !(id === null || id === void 0 ? void 0 : id.id) && id.tractStackId ? "Context" : "Pane",
                parentId: (id === null || id === void 0 ? void 0 : id.id) ? id.id : id.tractStackId,
                hasMaxHScreen: hasMaxHScreen,
                hasOverflowHidden: hasOverflowHidden,
                hasHiddenPane: hasHiddenPane,
                hasCodeHook: hasCodeHook,
                heldBeliefs: heldBeliefs,
                withheldBeliefs: withheldBeliefs,
            };
        });
    });
    if (id === null || id === void 0 ? void 0 : id.tractStackId)
        contentMap[id.tractStackId] = {
            title: id.tractStackTitle,
            slug: id.tractStackSlug,
            type: "TractStack",
            parentId: id.tractStackId,
            heldBeliefs: null,
            withheldBeliefs: null,
        };
    if ((id === null || id === void 0 ? void 0 : id.id) && (id === null || id === void 0 ? void 0 : id.title) && (id === null || id === void 0 ? void 0 : id.slug)) {
        contentMap[id.id] = {
            title: id.title,
            slug: id.slug,
            type: "StoryFragment",
            parentId: id.tractStackId,
            tailwindBgColour: useTailwindBgColour,
            heldBeliefs: null,
            withheldBeliefs: null,
        };
        var storyFragment = {
            paneIds: paneIds,
            css: thisCss,
            hasH5P: hasH5P,
            impressions: impressions,
        };
        return {
            storyFragment: storyFragment,
            contentMap: contentMap,
            contentChildren: contentChildren,
        };
    }
    return {
        contentMap: contentMap,
        contentChildren: contentChildren,
    };
};
exports.Compositor = Compositor;
var PaneCompositor = function (payload, viewportKey, hooks, id) {
    var optionsPayload = (payload === null || payload === void 0 ? void 0 : payload.optionsPayload)
        ? (0, exports.ParseOptions)(payload.optionsPayload)
        : null;
    var hasCodeHook = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.codeHook;
    var hasHiddenPane = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.hiddenPane;
    var hasH5P = hasCodeHook && hasCodeHook.target === "h5p";
    var impressionsPayload = (id === null || id === void 0 ? void 0 : id.id) &&
        (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.impressions) &&
        (0, exports.ParseImpressions)(optionsPayload.impressions, id.id);
    var maxHeightScreen = !!(optionsPayload &&
        optionsPayload["max-h-screen"] &&
        optionsPayload["max-h-screen"] === true);
    var hasOverflowHidden = !!(optionsPayload &&
        optionsPayload.overflowHidden &&
        optionsPayload.overflowHidden === true);
    var heldBeliefs = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.heldBeliefs;
    var withheldBeliefs = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.withheldBeliefs;
    var paneHeightRatio = payload.heightRatio
        ? payload.heightRatio
        : viewportKey === "desktop" && payload.heightRatioDesktop
            ? payload.heightRatioDesktop
            : viewportKey === "tablet" && payload.heightRatioTablet
                ? payload.heightRatioTablet
                : viewportKey === "mobile" && payload.heightRatioMobile
                    ? payload.heightRatioMobile
                    : "0";
    var paneHeight = (helper_1.viewportWidth[viewportKey] * Number(paneHeightRatio)) / 100;
    var paneHeightOffsetViewport = viewportKey === "desktop"
        ? payload.heightOffsetDesktop
        : viewportKey === "tablet"
            ? payload.heightOffsetTablet
            : viewportKey === "mobile"
                ? payload.heightOffsetMobile
                : null;
    var cssContainer = typeof paneHeightOffsetViewport === "number" && paneHeightOffsetViewport
        ? "#wrapper-".concat(viewportKey, "-").concat(payload.id, " { margin-top: calc(var(--scale) * ").concat(paneHeightOffsetViewport.toString(), " * 1px ); } ")
        : "";
    var compositing = optionsPayload.paneFragmentsPayload
        .filter(function (e) {
        return typeof (e === null || e === void 0 ? void 0 : e.hiddenViewports) === "string" &&
            !e.hiddenViewports.includes(viewportKey);
    })
        .sort(function (a, b) { return ((a === null || a === void 0 ? void 0 : a.field_zindex) || 0) - ((b === null || b === void 0 ? void 0 : b.field_zindex) || 0); })
        .map(function (f) {
        var _a, _b;
        switch ((_a = f === null || f === void 0 ? void 0 : f.internal) === null || _a === void 0 ? void 0 : _a.type) {
            case "markdown":
                return ParagraphMarkdownCompositor(__assign(__assign({}, f), { relationships: __assign({ markdown: payload.relationships.markdown }, f.relationships) }), viewportKey, paneHeight, hooks, payload.id, id);
            case "bgPane":
                return ParagraphBackgroundPaneCompositor(f, viewportKey);
            // case `paragraph__background_image`:
            //  return ParagraphBackgroundImageCompositor(f, viewportKey, hooks)
            // case `paragraph__background_video`:
            //  return ParagraphBackgroundVideoCompositor(f, viewportKey)
            // case `paragraph__svg`:
            //  return ParagraphSvgCompositor(f, viewportKey)
            case "bgColour":
                return ParagraphBackgroundColourCompositor(f, viewportKey, payload.id);
            default:
                console.log("No compositor for ".concat((_b = f === null || f === void 0 ? void 0 : f.internal) === null || _b === void 0 ? void 0 : _b.type));
                return null;
        }
    });
    var thisChildren = compositing
        .map(function (e) {
        return (e === null || e === void 0 ? void 0 : e.children) || null;
    })
        .filter(function (n) { return n; });
    var thisCss = compositing
        .map(function (e) {
        return (e === null || e === void 0 ? void 0 : e.css) || null;
    })
        .filter(function (n) { return n; });
    var thisCssJoined = thisCss.join(" ");
    return {
        slug: payload.slug,
        children: thisChildren || [],
        css: "".concat(thisCssJoined, " ").concat(cssContainer).replace(/\s\s+/g, ""),
        impressions: impressionsPayload,
        hasH5P: hasH5P,
        hasHiddenPane: hasHiddenPane,
        hasCodeHook: hasCodeHook,
        hasMaxHScreen: maxHeightScreen,
        hasOverflowHidden: hasOverflowHidden,
        heldBeliefs: heldBeliefs,
        withheldBeliefs: withheldBeliefs,
    };
};
var ParagraphMarkdownCompositor = function (payload, viewportKey, paneHeight, hooks, parent, id) {
    var _a, _b, _c, _d, _e, _f;
    var optionsPayload = payload.optionsPayload;
    var hasModal = payload === null || payload === void 0 ? void 0 : payload.isModal;
    var thisId = "".concat(viewportKey, "-").concat(payload.id, "-markdown");
    var thisIdModal = "".concat(viewportKey, "-").concat(payload.id, "-modal");
    var zIndex = ""; // `z-index: ${payload?.zindex || `100`};`
    var zIndexModal = hasModal
        ? "z-index: ".concat((payload.zindex - 1).toString() || "99", ";")
        : false;
    var thisTextShapeOutsideSelector = viewportKey === "desktop"
        ? payload.textShapeOutsideDesktop
        : viewportKey === "tablet"
            ? payload.textShapeOutsideTablet
            : viewportKey === "mobile"
                ? payload.textShapeOutsideMobile
                : payload.textShapeOutside;
    var thisImageMaskShapeSelector = viewportKey === "desktop"
        ? payload.imageMaskShapeDesktop
        : viewportKey === "tablet"
            ? payload.imageMaskShapeTablet
            : viewportKey === "mobile"
                ? payload.imageMaskShapeMobile
                : payload.imageMaskShape;
    var hasModalShapeOutside = hasModal && thisTextShapeOutsideSelector !== "none"
        ? thisTextShapeOutsideSelector
        : false;
    var isModal = typeof optionsPayload.modal !== "undefined" &&
        typeof optionsPayload.modal[viewportKey] !== "undefined";
    var thisModalPayload = isModal ? optionsPayload.modal[viewportKey] : null;
    var hasModalShapeOutsidePayload = isModal && hasModalShapeOutside
        ? (0, helper_1.SvgShapeOutsidePayload)(hasModalShapeOutside, viewportKey, thisIdModal, paneHeight, isModal, thisModalPayload)
        : false;
    var hasTextShapeOutsidePayload = thisTextShapeOutsideSelector &&
        typeof thisTextShapeOutsideSelector === "string"
        ? (0, helper_1.SvgShapeOutsidePayload)(thisTextShapeOutsideSelector, viewportKey, thisId, paneHeight, isModal, thisModalPayload)
        : false;
    var hasMaskPayload = thisImageMaskShapeSelector && thisImageMaskShapeSelector.length
        ? (0, helper_1.SvgImageMaskPayload)(thisImageMaskShapeSelector, thisId, viewportKey)
        : false;
    var hasModalMaskPayload = isModal && thisImageMaskShapeSelector && (thisImageMaskShapeSelector === null || thisImageMaskShapeSelector === void 0 ? void 0 : thisImageMaskShapeSelector.length)
        ? (0, helper_1.SvgImageMaskPayload)(thisImageMaskShapeSelector, thisIdModal, viewportKey)
        : false;
    var cssModalMask = hasModalMaskPayload || "";
    var imageDataArrayNew = (_b = (_a = payload === null || payload === void 0 ? void 0 : payload.relationships) === null || _a === void 0 ? void 0 : _a.markdown) === null || _b === void 0 ? void 0 : _b.map(function (e) {
        var _a, _b;
        return (_a = e === null || e === void 0 ? void 0 : e.relationships) === null || _a === void 0 ? void 0 : _a.images.concat((_b = e === null || e === void 0 ? void 0 : e.relationships) === null || _b === void 0 ? void 0 : _b.imagesSvg);
    })[0];
    var imageDataArray = typeof imageDataArrayNew === "object" &&
        Object.keys(imageDataArrayNew).length > 0
        ? imageDataArrayNew
        : (_c = payload === null || payload === void 0 ? void 0 : payload.relationships) === null || _c === void 0 ? void 0 : _c.image;
    var htmlAst = (payload === null || payload === void 0 ? void 0 : payload.markdownId)
        ? payload.relationships.markdown.filter(function (e) { return e.id === payload.markdownId; })[0]
            .childMarkdown.childMarkdownRemark
        : (_d = payload === null || payload === void 0 ? void 0 : payload.childPaneFragment) === null || _d === void 0 ? void 0 : _d.childMarkdownRemark;
    var astPayload = htmlAst && {
        ast: (_e = htmlAst === null || htmlAst === void 0 ? void 0 : htmlAst.htmlAst) === null || _e === void 0 ? void 0 : _e.children,
        mode: "paragraph__markdown",
        buttonData: optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.buttons,
        imageData: imageDataArray,
        parent: parent,
        viewportKey: viewportKey,
    };
    var hasClassNames = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNames;
    var hasClassNamesAll = (_f = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNames) === null || _f === void 0 ? void 0 : _f.all;
    var hasClassNamesViewport = hasClassNames &&
        typeof optionsPayload.classNames[viewportKey] !== "undefined";
    var injectClassNames = hasClassNamesAll
        ? optionsPayload.classNames.all
        : hasClassNamesViewport
            ? optionsPayload.classNames[viewportKey]
            : "";
    var hasClassNamesParent = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesParent;
    var hasClassNamesParentAll = hasClassNamesParent && optionsPayload.classNamesParent.all;
    var hasClassNamesParentViewport = hasClassNamesParent &&
        typeof (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesParent[viewportKey]) !== "undefined";
    var classNamesParent = hasClassNamesParentAll
        ? optionsPayload.classNamesParent.all
        : hasClassNamesParentViewport
            ? optionsPayload.classNamesParent[viewportKey]
            : "";
    var hasClassNamesModal = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesModal;
    var hasClassNamesModalAll = hasClassNamesModal && optionsPayload.classNamesModal.all;
    var hasClassNamesModalViewport = hasClassNamesModal &&
        typeof (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesModal[viewportKey]) !== "undefined";
    var classNamesModal = hasClassNamesModalAll
        ? optionsPayload.classNamesModal.all
        : hasClassNamesModalViewport
            ? optionsPayload.classNamesModal[viewportKey]
            : "";
    var markdownArray = astPayload ? ((0, helper_1.HtmlAstToReact)(astPayload, false, injectClassNames, hooks, {}, __assign(__assign({}, id), { viewportKey: viewportKey }))) : (react_1.default.createElement(react_1.default.Fragment, null));
    var cssMask = hasMaskPayload || "";
    var cssTextShapeOutside = hasTextShapeOutsidePayload
        ? hasTextShapeOutsidePayload.css
        : "";
    var cssShapeOutsideModal = hasModalShapeOutsidePayload
        ? hasModalShapeOutsidePayload.css
        : "";
    var css = "#".concat(thisId, " { ").concat(zIndex, " ").concat(cssMask, " } ").concat(cssTextShapeOutside, " ");
    var cssModal = hasModal
        ? "#".concat(thisIdModal, " { ").concat(zIndexModal, " ").concat(cssModalMask, " } ").concat(cssShapeOutsideModal, " ")
        : "";
    var working;
    if (!classNamesParent)
        working = markdownArray;
    else if (typeof classNamesParent === "string")
        working = react_1.default.createElement("div", { className: classNamesParent }, markdownArray);
    else
        classNamesParent.reverse().forEach(function (e) {
            if (typeof working === "undefined")
                working = react_1.default.createElement("div", { className: e }, markdownArray);
            else
                working = react_1.default.createElement("div", { className: e }, working);
        });
    var thisMarkdown = working;
    var jsxMarkdown = hasTextShapeOutsidePayload ? (react_1.default.createElement("div", { id: thisId, key: thisId, className: "paneFragment paneFragment-".concat(viewportKey, " paneFragmentParagraphOutside") },
        hasTextShapeOutsidePayload.left,
        hasTextShapeOutsidePayload.right,
        thisMarkdown)) : (react_1.default.createElement("div", { id: thisId, key: thisId, className: "paneFragment paneFragmentParagraph" }, thisMarkdown));
    var jsxModal = hasModalShapeOutsidePayload &&
        typeof hasModalShapeOutsidePayload === "object" ? (react_1.default.createElement("div", { id: "".concat(thisIdModal), key: "".concat(thisIdModal), className: (0, helper_1.classNames)("paneFragment paneFragmentModal", classNamesModal) }, hasModalShapeOutsidePayload === null || hasModalShapeOutsidePayload === void 0 ? void 0 : hasModalShapeOutsidePayload.shape)) : null;
    var thisJsx = !isModal ? [jsxMarkdown] : [jsxModal, jsxMarkdown];
    return {
        children: thisJsx,
        css: "".concat(css, " ").concat(cssModal),
    };
};
var ParagraphBackgroundPaneCompositor = function (payload, viewportKey) {
    var zIndex = ""; // `z-index: ${payload?.zindex || `100`};`
    var optionsPayload = payload.optionsPayload;
    var hasArtpack = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.artpack;
    var hasArtpackAll = hasArtpack === null || hasArtpack === void 0 ? void 0 : hasArtpack.all;
    var hasArtpackViewport = hasArtpack &&
        typeof hasArtpack[viewportKey] !== "undefined" &&
        hasArtpack[viewportKey];
    var artpack = (hasArtpack && hasArtpackAll) || hasArtpackViewport;
    var artpackMode = artpack === null || artpack === void 0 ? void 0 : artpack.mode;
    var artpackFiletype = artpack === null || artpack === void 0 ? void 0 : artpack.filetype;
    var artpackCollection = artpack === null || artpack === void 0 ? void 0 : artpack.collection;
    var viewportPrefix = viewportKey === "desktop" || viewportKey === "tablet" ? "1920" : "800";
    var filenamePrefix = artpackCollection !== "custom" ? "".concat(artpackCollection, "-") : "";
    var artpackImage = artpack === null || artpack === void 0 ? void 0 : artpack.image;
    var thisId = "".concat(viewportKey, "-").concat(payload.id, "-pane");
    var thisShapeSelector = viewportKey === "desktop"
        ? payload.shapeDesktop
        : viewportKey === "tablet"
            ? payload.shapeTablet
            : viewportKey === "mobile"
                ? payload.shapeMobile
                : payload.shape;
    var shapeName = thisShapeSelector !== "none" ? thisShapeSelector : null;
    var shape = typeof shapeName === "string" ? (0, helper_1.Svg)(shapeName, viewportKey, thisId) : react_1.default.createElement(react_1.default.Fragment, null);
    var hasClassNamesParent = optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesParent;
    var hasClassNamesParentAll = hasClassNamesParent && optionsPayload.classNamesParent.all;
    var hasClassNamesParentViewport = hasClassNamesParent &&
        typeof (optionsPayload === null || optionsPayload === void 0 ? void 0 : optionsPayload.classNamesParent[viewportKey]) !== "undefined";
    var classNamesParent = hasClassNamesParentAll
        ? optionsPayload.classNamesParent.all
        : hasClassNamesParentViewport
            ? optionsPayload.classNamesParent[viewportKey]
            : "";
    // modes -- standard = as-is
    // break = use artpack, show svg (from shapes), no mask
    // mask = use artpack, show image via css url, apply mask via css
    var breakSvg = artpackMode === "break" &&
        typeof artpackImage === "string" &&
        typeof artpackCollection === "string"
        ? (0, helper_1.Svg)("".concat(artpackCollection).concat(artpackImage), thisId, viewportKey)
        : false;
    var breakSvgFill = breakSvg && typeof (artpack === null || artpack === void 0 ? void 0 : artpack.svgFill) === "string" ? artpack.svgFill : "none";
    var maskSvg = artpackMode === "mask" && shapeName
        ? (0, helper_1.SvgImageMaskPayload)(shapeName, thisId, viewportKey)
        : false;
    // @ts-ignore
    var maskObjectFit = maskSvg && typeof (artpack === null || artpack === void 0 ? void 0 : artpack.objectFit) === "string"
        ? artpack.objectFit
        : "cover";
    var thisShape = breakSvg || (maskSvg ? react_1.default.createElement(react_1.default.Fragment, null) : shape);
    var breakCss = breakSvg ? "#".concat(thisId, " svg { fill: ").concat(breakSvgFill, "; }") : "";
    var url = "/".concat(artpackCollection, "-artpack/").concat(filenamePrefix).concat(viewportPrefix, "/").concat(artpackImage, ".").concat(artpackFiletype);
    var maskCss = maskSvg &&
        artpackCollection &&
        artpackImage &&
        artpackFiletype &&
        maskObjectFit
        ? "#".concat(thisId, " { background:url('").concat(url, "'); background-size:").concat(maskObjectFit, "; ").concat(zIndex, " ").concat(maskSvg, " }")
        : "";
    var css = "#".concat(thisId, " { ").concat(zIndex, " } ").concat(breakCss, " ").concat(maskCss);
    var thisJsx = [
        react_1.default.createElement("div", { id: thisId, key: thisId, className: (0, helper_1.classNames)("paneFragment paneFragmentShape", classNamesParent) }, thisShape),
    ];
    return {
        children: thisJsx,
        css: css,
    };
};
/*
const ParagraphBackgroundImageCompositor = (
  payload: IPaneFragmentBackgroundImage,
  viewportKey: string,
  hooks: IStoryFragmentHooks,
) => {
  const thisId = `${viewportKey}-${payload.id}-image`
  const getImage = hooks.getImage
  const GatsbyImage: any = hooks.GatsbyImage
  const zIndex = `` // `z-index: ${payload?.zindex || `100`};`
  const altText =
    payload?.altText ||
    `We care about A11y and apologize for this missing image description. This should not happen.`
  const backgroundPosition = payload?.bgPosition || `center`
  const optionsPayload = payload.optionsPayload
  const parallaxSpeed = optionsPayload?.parallaxSpeed || false
  const maxHeightScreen =
    optionsPayload &&
    optionsPayload[`max-h-screen`] &&
    optionsPayload[`max-h-screen`] === true
      ? `max-height: 100vh; `
      : ``
  const maxHeightScreenMore =
    maxHeightScreen !== ``
      ? `#${thisId} section { max-height:100vh; } ` +
        `#${thisId} .gatsby-image-wrapper { max-height:100vh; } `
      : ``
  const thisMaskShape =
    viewportKey === `desktop`
      ? payload.imageMaskShapeDesktop
      : viewportKey === `tablet`
      ? payload.imageMaskShapeTablet
      : viewportKey === `mobile`
      ? payload.imageMaskShapeMobile
      : payload.imageMaskShape
  const hasMaskShape = thisMaskShape !== `none` ? thisMaskShape : false
  const hasMaskPayload =
    hasMaskShape && hasMaskShape.length
      ? SvgImageMaskPayload(hasMaskShape, thisId, viewportKey)
      : false
  const cssMask = hasMaskPayload || ``
  const objectFit = optionsPayload?.objectFit || `cover`
  const imageData = payload?.relationships?.image[0] // only takes first image
  const imageDataThisViewport =
    imageData[viewportKey].childImageSharp.gatsbyImageData
  const image = imageDataThisViewport && getImage(imageDataThisViewport)

  const css =
    `#${thisId} { ${maxHeightScreen} ${zIndex} ${cssMask} } ${maxHeightScreenMore} ` +
    `#${thisId} .gatsby-image-wrapper { height:100%; } `
  const thisJsx = image ? (
    <div
      id={thisId}
      key={thisId}
      className="paneFragment paneFragmentImage grid place-items-center"
    >
      <GatsbyImage
        image={image}
        alt={altText}
        style={{ backgroundPosition }}
        objectFit={objectFit}
      />
    </div>
  ) : (
    <></>
  )
  const thisJsxWrapper = parallaxSpeed ? (
    <div key={thisId}>
      <ParallaxProvider>
        <Parallax speed={parallaxSpeed}>{thisJsx}</Parallax>
      </ParallaxProvider>
    </div>
  ) : (
    thisJsx
  )
  return {
    children: [thisJsxWrapper],
    css,
  }
}

const ParagraphBackgroundVideoCompositor = (
  payload: IPaneFragmentBackgroundVideo,
  viewportKey: string,
) => {
  const thisId = `${viewportKey}-${payload.id}-video`
  const zIndex = `` // `z-index: ${payload?.zindex || `100`};`
  const hasMaskShape =
    payload.imageMaskShape !== `none` ? payload.imageMaskShape : null
  const hasMaskPayload =
    hasMaskShape && hasMaskShape.length
      ? SvgImageMaskPayload(hasMaskShape, thisId, viewportKey)
      : false
  const cssMask = hasMaskPayload || ``
  const url = payload?.cdnUrl
  const altText =
    payload?.altText ||
    `We care about accessibility and apologize for this missing video description. This should not happen.`
  const css = `#${thisId} { ${zIndex} ${cssMask} }`
  const thisJsx = (url && altText && (
    <div id={thisId} key={thisId} className="paneFragment paneFragmentVideo">
      <video autoPlay={true} muted loop title={altText}>
        <source src={url} type="video/mp4" />
      </video>
    </div>
  )) || <></>
  return {
    children: [thisJsx],
    css,
  }
}

const ParagraphSvgCompositor = (
  payload: IPaneFragmentSvg,
  viewportKey: string,
) => {
  const thisId = `${viewportKey}-${payload.id}-svg`
  const zIndex = `` // `z-index: ${payload?.zindex || `101`};`
  const optionsPayload = payload.optionsPayload
  const parallaxSpeed = optionsPayload?.parallaxSpeed || false
  const hasMaskShape =
    payload.imageMaskShape !== `none` ? payload.imageMaskShape : false
  const hasMaskPayload =
    hasMaskShape && hasMaskShape.length
      ? SvgImageMaskPayload(hasMaskShape, thisId, viewportKey)
      : false
  const cssMask = hasMaskPayload || ``
  const url = payload?.relationships?.svgFile?.localFile?.publicURL
  const altText =
    payload?.svgTitle?.description ||
    `We care about accessibility and apologize for this missing video description. This should not happen.`
  const css = `#${thisId} { ${zIndex} ${cssMask} } `
  const thisJsx = (url && altText && (
    <div id={thisId} key={thisId} className="paneFragment paneFragmentSvg">
      <img src={url} alt={altText} />
    </div>
  )) || <></>
  const thisJsxWrapper = parallaxSpeed ? (
    <div key={thisId}>
      <ParallaxProvider>
        <Parallax speed={parallaxSpeed}>{thisJsx}</Parallax>
      </ParallaxProvider>
    </div>
  ) : (
    thisJsx
  )

  return {
    children: [thisJsxWrapper],
    css,
  }
}
*/
var ParagraphBackgroundColourCompositor = function (payload, viewportKey, paneId) {
    var bgColour = (typeof payload.bgColour === "string" &&
        "background-color: ".concat(payload.bgColour, ";")) ||
        "";
    var zIndex = ""; // `z-index: 50;`
    var thisId = "".concat(viewportKey, "-").concat(paneId);
    var css = "#".concat(thisId, " { ").concat(bgColour, " ").concat(zIndex, " } ");
    return {
        children: [],
        css: css,
    };
};
var ParseOptions = function (payload) {
    var action;
    try {
        action = JSON.parse(payload);
    }
    catch (e) {
        if (e instanceof SyntaxError) {
            console.log("ERROR parsing json options: ", e);
            return null;
        }
    }
    return action;
};
exports.ParseOptions = ParseOptions;
var ParseImpressions = function (payload, parent) {
    var thisPayload = [];
    Object.keys(payload).forEach(function (impression) {
        var thisImpression = payload[impression];
        thisPayload.push(thisImpression);
        thisImpression.parentId = parent;
    });
    return {
        payload: thisPayload,
    };
};
exports.ParseImpressions = ParseImpressions;
//# sourceMappingURL=compositor.js.map