"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lispLexer = void 0;
var DOUBLEQUOTE = ["\""];
var BRACKETLEFT = "(";
var BRACKETRIGHT = ")";
var SEMICOLON = ";";
var NEWLINE = "\n";
var WHITESPACE = [" ", "\n", "\t"];
function lispLexer(payload, inString) {
    if (payload === void 0) { payload = ""; }
    if (inString === void 0) { inString = false; }
    var tokens = [];
    var curToken = "";
    for (var i = 0; i < payload.length; i++) {
        var char = payload.charAt(i);
        if (DOUBLEQUOTE.includes(char) && inString === false) {
            var _a = lispLexer(payload.substring(i + 1), true), tokenized = _a[0], remaining = _a[1];
            tokens.push(tokenized);
            payload = remaining;
            i = -1;
        }
        else if (DOUBLEQUOTE.includes(char)) {
            if (curToken.length) {
                tokens.push(+curToken || curToken);
            }
            return [tokens, payload.substring(i + 1)];
        }
        else if (char === BRACKETLEFT) {
            // if (inString && payload?.charAt(i - 1) === ESCAPED) throw "PARSING ERROR"
            var _b = lispLexer(payload.substring(i + 1)), tokenized = _b[0], remaining = _b[1];
            tokens.push(tokenized);
            payload = remaining;
            i = -1;
        }
        else if (char === BRACKETRIGHT) {
            // if (inString && payload?.charAt(i - 1) === ESCAPED) throw "PARSING ERROR"
            if (curToken.length) {
                tokens.push(+curToken || curToken);
            }
            return [tokens, payload.substring(i + 1)];
        }
        else if (char === SEMICOLON) {
            // skip comments
            while (payload.charAt(i) !== NEWLINE) {
                i++;
            }
        }
        else if (WHITESPACE.includes(char) && inString !== true) {
            if (curToken.length) {
                tokens.push(+curToken || curToken);
            }
            curToken = "";
        }
        else {
            curToken += char;
        }
    }
    return [tokens, ""];
}
exports.lispLexer = lispLexer;
//# sourceMappingURL=lexer.js.map